=begin
#ChannelShipper & Royal Mail Public API

#Import your orders, retrieve your orders and generate labels.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module RoyalMail
  class LabelsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Return a single PDF file with generated label and/or associated document(s)
    # <b>Reserved for OBA customers only</b>  The account \"Label format\" settings page will control the page format settings used to print the postage label and associated documents. Certain combinations of these settings may prevent associated documents from being printed together with the postage label within a single document. If this occurs the documentType option can be used in a separate call to print missing documents. 
    # @param order_identifiers One or several Order Identifiers or Order References separated by semicolon. Order Identifiers are integer numbers. Order References are strings - each must be percent-encoded and surrounded by double quotation marks. The maximum number of identifiers is 100.
    # @param document_type Document generation mode. When documentType is set to \&quot;postageLabel\&quot; the additional parameters below must be used. These additional parameters will be ignored when documentType is not set to \&quot;postageLabel\&quot;
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_returns_label Include returns label. Required when documentType is set to &#x27;postageLabel&#x27;
    # @option opts [BOOLEAN] :include_cn Include CN22/CN23 with label. Optional parameter. If this parameter is used the setting will override the default account behaviour specified in the \&quot;Label format\&quot; setting \&quot;Generate customs declarations with orders\&quot;
    # @return [String]
    def get_orders_label_async(order_identifiers, document_type, opts = {})
      data, _status_code, _headers = get_orders_label_async_with_http_info(order_identifiers, document_type, opts)
      data
    end

    # Return a single PDF file with generated label and/or associated document(s)
    # &lt;b&gt;Reserved for OBA customers only&lt;/b&gt;  The account \&quot;Label format\&quot; settings page will control the page format settings used to print the postage label and associated documents. Certain combinations of these settings may prevent associated documents from being printed together with the postage label within a single document. If this occurs the documentType option can be used in a separate call to print missing documents. 
    # @param order_identifiers One or several Order Identifiers or Order References separated by semicolon. Order Identifiers are integer numbers. Order References are strings - each must be percent-encoded and surrounded by double quotation marks. The maximum number of identifiers is 100.
    # @param document_type Document generation mode. When documentType is set to \&quot;postageLabel\&quot; the additional parameters below must be used. These additional parameters will be ignored when documentType is not set to \&quot;postageLabel\&quot;
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_returns_label Include returns label. Required when documentType is set to &#x27;postageLabel&#x27;
    # @option opts [BOOLEAN] :include_cn Include CN22/CN23 with label. Optional parameter. If this parameter is used the setting will override the default account behaviour specified in the \&quot;Label format\&quot; setting \&quot;Generate customs declarations with orders\&quot;
    # @return [Array<(String, Integer, Hash)>] String data, response status code and response headers
    def get_orders_label_async_with_http_info(order_identifiers, document_type, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LabelsApi.get_orders_label_async ...'
      end
      # verify the required parameter 'order_identifiers' is set
      if @api_client.config.client_side_validation && order_identifiers.nil?
        fail ArgumentError, "Missing the required parameter 'order_identifiers' when calling LabelsApi.get_orders_label_async"
      end
      # verify the required parameter 'document_type' is set
      if @api_client.config.client_side_validation && document_type.nil?
        fail ArgumentError, "Missing the required parameter 'document_type' when calling LabelsApi.get_orders_label_async"
      end
      # verify enum value
      if @api_client.config.client_side_validation && !['postageLabel', 'despatchNote', 'CN22', 'CN23'].include?(document_type)
        fail ArgumentError, "invalid value for 'document_type', must be one of postageLabel, despatchNote, CN22, CN23"
      end
      # resource path
      local_var_path = '/orders/{orderIdentifiers}/label'.sub('{' + 'orderIdentifiers' + '}', order_identifiers.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'documentType'] = document_type
      query_params[:'includeReturnsLabel'] = opts[:'include_returns_label'] if !opts[:'include_returns_label'].nil?
      query_params[:'includeCN'] = opts[:'include_cn'] if !opts[:'include_cn'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/pdf', 'application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'String' 

      auth_names = opts[:auth_names] || ['Bearer']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LabelsApi#get_orders_label_async\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
